# Generated by Django 2.0.4 on 2018-04-22 18:21

from django.db import migrations

PROVIDER_TO_REMOVE = {
    'name': 'Google Maps',
    'type': 'M',
    'url_scheme': 'comgooglemaps://?daddr={latitude},{longitude}&directionsmode=driving'
}

PROVIDER_TO_CHANGE = {
    'name': 'Google Maps',
    'type': 'D',
    'url_scheme': 'https://maps.google.com?daddr={latitude},{longitude}&directionsmode=driving'
}


def remove_navigation_provider(apps, schema_editor):
    NavigationProvider = apps.get_model('gps', 'NavigationProvider')
    np = NavigationProvider.objects.filter(
        name__iexact=PROVIDER_TO_REMOVE['name'],
        type=PROVIDER_TO_REMOVE['type'],
        url_scheme=PROVIDER_TO_REMOVE['url_scheme']
    ).delete()


def rollback_remove_navigation_provider(apps, schema_editor):
    NavigationProvider = apps.get_model('gps', 'NavigationProvider')

    np = NavigationProvider.objects.filter(name__iexact=PROVIDER_TO_REMOVE['name'], type=PROVIDER_TO_REMOVE['type']).last()
    if np is None:
        NavigationProvider.objects.create(
            name=PROVIDER_TO_REMOVE['name'],
            url_scheme=PROVIDER_TO_REMOVE['url_scheme'],
            type=PROVIDER_TO_REMOVE['type']
        )


def change_navigation_provider(apps, schema_editor):
    NavigationProvider = apps.get_model('gps', 'NavigationProvider')

    np = NavigationProvider.objects.filter(
        name__iexact=PROVIDER_TO_CHANGE['name'],
        type=PROVIDER_TO_CHANGE['type'],
        url_scheme=PROVIDER_TO_CHANGE['url_scheme']
    ).last()
    if np:
        np.type = 'B'
        np.save()


def rollback_change_navigation_provider(apps, schema_editor):
    NavigationProvider = apps.get_model('gps', 'NavigationProvider')

    np = NavigationProvider.objects.filter(
        name__iexact=PROVIDER_TO_CHANGE['name'],
        type='B',
        url_scheme=PROVIDER_TO_CHANGE['url_scheme']
    ).last()
    if np:
        np.type = PROVIDER_TO_CHANGE['type']
        np.save()


class Migration(migrations.Migration):
    dependencies = [
        ('gps', '0013_auto_20180422_2020'),
    ]

    operations = [
        migrations.RunPython(remove_navigation_provider, rollback_remove_navigation_provider),
        migrations.RunPython(change_navigation_provider, rollback_change_navigation_provider),
    ]
